function A=condicion_derivadas_A(h,CI,CD)

% Esta matriz sern los coeficientes que acompaan a los eta para
% condiciones en la frontera CI=1 y CD=1 es decir de segundo primer tipo en ambos extremos
% A es el trmino que acompaa a los eta tal que
% eta=6Hz+F
% Este sistema de ecuaciones viene de la condicin de continuidad de la
% primera derivada de la funcin Spline.

% Variables de entrada:
% h=vector h de distancias entre las abscisas
n=length(h);

% La primera ecuacin
if CI==1
    A(1,1)=h(1)/3; A(1,2)=h(1)/6;
elseif CI==2
    A(1,1)=1; 
elseif CI==3
    A(1,1)=1; A(1,n+1)=-1;
end

% Definimos el bucle que calcular los trminos intermedios
for i=2:n
    A(i,i)=2*(h(i-1)+h(i));
    A(i,i+1)=h(i);
    A(i,i-1)=h(i-1);
end

% La ltima ecuacin
if CD==1
    A(n+1,n)=-h(n)/6; A(n+1,n+1)=-h(n)/3;
elseif CD==2
    A(n+1,n+1)=1;
elseif CD==3
   A(n+1,1)=2*h(1); A(n+1,2)=h(1); A(n+1,n)=h(n); A(n+1,n+1)=2*h(n);
end