function U=relacion_EtaLambda_U(h)

% Matriz coeficientes obtenida de la expresin del funcional, (dJ(s))/dEta)
% U*Eta=V*lambda
% U es la matriz que acompaa a lambda

% Variables de entrada:
% h=vector h de distancias entre las abscisas

% n es la dimensin del vector h
n=length(h);

% Definimos los trminos invariantes
U(1,1)=2/3*h(1);
U(1,2)=h(1)/3;
U(n+1,n)=h(n)/3;
U(n+1,n+1)=2/3*h(n);

% Definimos el bucle que calcular el resto de trminos
for i=2:n
    U(i,i)=2/3*(h(i-1)+h(i));
    U(i,i+1)=h(i)/3;
    U(i,i-1)=h(i-1)/3;
end

