function J=relacion_ZetaLambda_J(h,CI,CD)

% Variables de entrada
% h=vector espaciado nodos
% De la minimizacin del funcional  y  (dJ(s))/dz
% se obtiene la relacin
% Z=Y+1/2*rho*lambda*J
% En este programa definimos la matriz J
% n es la dimensin del vector h

n=length(h);

J=zeros(n+1,n+1);

% La primera ecuacin
if CI==1
    J(1,1)=1/h(1); J(1,2)=-1/h(1);
    J(2,1)=-1/h(1); J(2,2)=1/h(1)+1/h(2); J(2,3)=-1/h(2); 
elseif CI==2
    J(1,1)=0; J(1,2)=-1/h(1);
    J(2,1)=0; J(2,2)=1/h(1)+1/h(2); J(2,3)=-1/h(2); 
elseif CI==3
    J(1,1)=0; J(1,2)=-1/2*1/h(1); J(1,n)=-1/2*1/h(n); J(1,n+1)=1/2*1/h(1)+1/2*1/h(n);
    J(2,1)=0; J(2,2)=1/h(1)+1/h(2); J(2,3)=-1/h(2); J(2,n+1)=-1/h(1);
elseif CI==4
    J(1,1)=-1; J(1,2)=-1/h(1);
    J(2,1)=0; J(2,2)=1/h(1)+1/h(2); J(2,3)=-1/h(2);  
end 


% Definimos el bucle que calcular calcular los trminos intermedios

for i=3:n-1
    J(i,i)=1/h(i-1)+1/h(i);
    J(i-1,i)=-1/h(i-1);
    J(i+1,i)=-1/h(i);
end


% La ltima ecuacin
if CD==1
    J(n+1,n)=-1/h(n); J(n+1,n+1)=-1/h(n);
    J(n,n-1)=-1/h(n-1); J(n,n)=1/h(n-1)+1/h(n); J(n,n+1)=1/h(n);
elseif CD==2
    J(n+1,n)=-1/h(n); J(n+1,n+1)=0;
    J(n,n-1)=-1/h(n-1); J(n,n)=1/h(n-1)+1/h(n); J(n,n+1)=0;
elseif CD==3
     J(n,n-1)=-1/h(n-1); J(n,n)=1/h(n-1)+1/h(n); J(n,n+1)=-1/h(n);
     J(n+1,2)=-1/2*1/h(1); J(n+1,n)=-1/2*1/h(n); J(n+1,n+1)=1/2*1/h(n)+1/2*1/h(1);
elseif CD==4
     J(n,n-1)=-1/h(n-1); J(n,n)=1/h(n-1)+1/h(n);
     J(n+1,n)=1/h(n); J(n+1,n+1)=-1;

end
